#ifndef MODINITTOOLS_CACHE_H
#define MODINITTOOLS_CACHE_H

struct dep_cache {
	char magic[sizeof "mod-dep-cache"];
	unsigned char version;
	unsigned char pad;
	unsigned int endian;
	unsigned int moddep_mtime_high;
	unsigned int moddep_mtime_low;
	unsigned int moddep_size;
	unsigned int moddep_ino;
	unsigned int hash_size;
	unsigned int hash_offset;
	unsigned int dir_table_offset;
};

struct dep_cache_entry {
	unsigned int hash;
	unsigned int next;
	unsigned int modname;
	unsigned int modname_len;
	unsigned int fullname;
	unsigned int num_dependencies;
	unsigned int dependencies[];
};

static inline unsigned int dep_cache_hash (const char *str, size_t len)
{
  size_t n = 0;
  unsigned int r = 0;

  for (n = 0; n < len; n++, str++)
    r = r * 67 + (*str == '-' ? '_' : *str) - 113;
  return r + len;
}

struct alias_cache {
	char magic[sizeof "mod-alias-cache"];
	unsigned char version;
	unsigned char pad[3];
	unsigned int endian;
	unsigned int modalias_mtime_high;
	unsigned int modalias_mtime_low;
	unsigned int modalias_size;
	unsigned int modalias_ino;
	unsigned int singles;
	unsigned int strings;
};

struct alias_cache_range {
	unsigned int nchars;
	unsigned int count_normal;
	unsigned int count_wild;
};

#endif /* MODINITTOOLS_CACHE_H */
